#include <Servo.h>

const int echoPin = 6;    // the pin that listens to the echo back
const int triggerPin = 3; // the pin that triggers the sonic pulses
const int servoPin = 7;   // the pin with servo

const int minAngle = 80; // minimum angle of the wave flag
const int maxAngle = 160; // max angle of the wave flag

Servo myservo;

int speedOfWaving = 1; // times per second we want the frenchman to wave the flag
float echoDuration;
int pos = 80;
int maxEcho = 11765; // could also be called maxEcho
int minEcho = 351; // could also be called maxEcho


void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  myservo.attach(servoPin);
}

void loop() {
  // put your main code here, to run repeatedly:
  
  digitalWrite(triggerPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(triggerPin, LOW);

  echoDuration = pulseIn(echoPin, HIGH);
  Serial.println(echoDuration);

  if (echoDuration < maxEcho) {
    echoDuration = map(echoDuration, minEcho, maxEcho, 1, 37);
  
    for (pos = minAngle; pos <= maxAngle; pos += 1) {
      // in steps of 1 degree
      myservo.write(pos);
      delay(echoDuration);
    }
    for (pos = maxAngle; pos >= minAngle; pos -= 1) {
      myservo.write(pos);
      delay(echoDuration);
    }
  }
  
  delay(60); // datasheet advise at least 60ms between measurements
}
